Getting Started with Toast Web Component

Smart UI Web Components work with current evergreen browsers and Node 18+ for local tooling; pin package versions to match your project policy.

Smart UI is distributed as the smart-webcomponents NPM package. You can also use the full download from the Download page.

Quick start

  1. Install the package:

    npm install smart-webcomponents

  2. Load the Toast module (ES module script):

    <script type="module" src="node_modules/smart-webcomponents/source/modules/smart.toast.js"></script>

  3. Add the default stylesheet (prefer angular.json / bundler entry in app codebases; for plain HTML use a link):

    <link rel="stylesheet" type="text/css" href="node_modules/smart-webcomponents/source/styles/smart.default.css" />

  4. Add markup in one of two ways - semantic custom element (the component tag is in your HTML) or a host div (you mount programmatically with appendTo):

    Semantic element (id matches the selector in Smart()):

    <smart-toast id="toast"></smart-toast>

    Host container (id matches appendTo on Smart.Toast):

    <div id="toastContainer"></div>

  5. Initialize after the module loads: define a const toastOptions object, then either bind with Smart('#toast', ...) on the semantic tag or use new Smart.Toast({ ...toastOptions, appendTo: '#toastContainer' }) on the host div:

    <script type="module">
    	import 'node_modules/smart-webcomponents/source/modules/smart.toast.js';
    
    	const toastOptions = { position: "top-left" };
    
    	// Option A - semantic <smart-toast> with id="toast"
    	Smart('#toast', class {
    		get properties() {
    			return toastOptions;
    		}
    	});
    
    	// Option B - host div id="toastContainer"
    	// const toastInstance = new Smart.Toast({
    	// 	...toastOptions,
    	// 	appendTo: '#toastContainer'
    	// });
    
    	// Option C - constructor(selector, options), then append the returned element yourself
    	// const myToast = new Smart.Toast('#toast', toastOptions);
    	// document.body.appendChild(myToast);
    </script>
    		

    Uncomment Option B when you use the host div; use Option A when you use the semantic element. The Runtime cookbook also documents new Smart.Toast('#toast', toastOptions) with appendChild, and document.createElement('smart-toast') with .props or Object.assign (all are valid patterns; do not combine overlapping patterns for the same instance unless you intend multiple components).

  6. Serve the folder over HTTP (or use your bundler dev server) and open the page.

Runtime cookbook

Alternative creation patterns and imperative APIs. These are all valid ways to create Smart UI components: semantic markup + Smart(); new Smart.Toast({ ...options, appendTo: '#...' }); new Smart.Toast('#toast', toastOptions) plus appendChild on the returned element; and document.createElement('smart-toast') then assigning options via .props or Object.assign on the element.

Constructor with a selector string and options, then append the returned element (for example const myToast = new Smart.Toast('#toast', toastOptions)):

	const toastOptions = { position: "top-left" };
	const myToast = new Smart.Toast('#toast', toastOptions);
	document.body.appendChild(myToast);
	

Create with document.createElement('smart-toast'), assign properties (same as any custom element), then append:

	const toastOptions = { position: "top-left" };
	const toast = document.createElement('smart-toast');
	Object.assign(toast, toastOptions);
	document.body.appendChild(toast);
	

Host on a div with appendTo (import the module, then instantiate when the document is ready; the container id must match appendTo):

	import "../../source/modules/smart.toast.js";

	document.readyState === 'complete' ? init() : window.addEventListener('load', init);

	function init() {
		const toastOptions = { position: "top-left" };
		const toast = new Smart.Toast({
			...toastOptions,
			appendTo: '#toastContainer'
		});
	}
	

Appearance

By default Smart.Toast's instance has text(set by value property), icon(set via CSS) and close button( it's visibility is controlled by showCloseButton property). This may be changed by applying custom template via itemTemplate property

By default newly opened toast instances are opened in the browsers top-right corner. This can be changed by setting the position property. There are four available options:

  • 'top-left' - renders newly opened toasts in the top-left browser's corner
  • 'top-right' - renders newly opened toasts in the top-right browser's corner
  • 'bottom-left' - renders newly opened toasts in the bottom-left browser's corner
  • 'bottom-right' - renders newly opened toasts in the bottom-right browser's corner

Demo

All toast instances are stored vertically in these common containers. The vertical order corresponds to the order of opening.

Another property, responsible about toast's positioning is appendTo. It allows toast rendering in custom container chosen by the user. If appendTo is set, then the position settings are disregarded.

 <smart-toast id="toast1" auto-open show-close-button class="animation blink">Alert!</smart-toast>
 <div class="toast-container" id="toastContainer2"></div>

Demo

The different toast type styling cane be set via set type property. Allowed values are 'info', 'warning', 'success', 'error', 'mail', 'time'.

 <smart-toast auto-open append-to="toastContainer" type="info">Alert!</smart-toast>
 <smart-toast auto-open append-to="toastContainer" type="warning">Alert!</smart-toast>
 <smart-toast auto-open append-to="toastContainer" type="success">Alert!</smart-toast>
 <smart-toast auto-open append-to="toastContainer" type="error">Alert!</smart-toast>
 <smart-toast auto-open append-to="toastContainer" type="mail">Alert!</smart-toast>
 <smart-toast auto-open append-to="toastContainer" type="time">Alert!</smart-toast>
 <div class="toast-container" id="toastContainer"></div>

Demo

Behavior

Smart.Toast could be modal. It's controlled by "modal" boolean property.

 <smart-toast modal type="success">Alert!</smart-toast>

Demo



The animation class added in Smart.Toast, produces smooth animation on open/close.

 <smart-toast auto-open class="animation">Alert!</smart-toast>

Demo



The blink class added in Smart.Toast, produces blinking effect when an instance is opened.

 <smart-toast auto-open type="error" class="blink">Alert!</smart-toast>

Demo

Manipulating the content

Smart.Toast allows updating the content of the last opened item by changing toast's value

 <script>
     window.onload = function () {
         var toast = document.getElementById('toast');
         toast.value = 'Toast\'s value is updated !!!';
     }
 </script>

Methods

open - opens a new toast instance

 <script>
     window.onload = function () {
         var toast = document.getElementById('toast');
         toast.open();
     }
 </script>

closeAll - closes all opened toast instances

 <script>
     window.onload = function () {
         var toast = document.getElementById('toast');
         toast.closeAll();
     }
 </script>

closeItem - closes particular toast instance

 <script>
     window.onload = function () {
         var toast = document.getElementById('toast');
         toast.closeItem('itemId');
     }
 </script>

closeLast - closes last opened instance

 <script>
     window.onload = function () {
         var toast = document.getElementById('toast');
         toast.closeLast();
     }
 </script>

Append to the DOM:

const container = document.getElementById('toast-container');
container.appendChild(toast);
	

Remove from the DOM:

toast.remove();
	

Set a property:

toast.disabled = true;
toast.theme = 'dark';
	

Get a property value:

const isDisabled = toast.disabled;
const currentTheme = toast.theme;
	

Invoke a method:

toast.refresh();
toast.focus();
	

Add event listener:

toast.addEventListener('itemClick', (event) => {
    console.log('itemClick triggered:', event.detail);
});
	

Remove event listener:

const handleToastEvent = (event) => {
    console.log('itemClick triggered:', event.detail);
};

toast.addEventListener('itemClick', handleToastEvent);
toast.removeEventListener('itemClick', handleToastEvent);
	

Common Use Cases

  • Show notification

    Display a toast message

    toast.open();
  • Auto-close notification

    Set toast to dismiss automatically

    toast.autoClose = true;
    toast.autoCloseDelay = 3000;
    toast.open();

Troubleshooting

How do I show different toast types?
Set the type property to 'info', 'success', 'warning', or 'error' for different visual styles.
How do I position toasts?
Set the position property to 'top-left', 'top-right', 'bottom-left', or 'bottom-right'.

Accessibility

The Toast component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Getting Started with React Toast Component

Smart UI React targets React 18+ and current Node LTS for tooling; use TypeScript templates when you want typed props and events.

Demo source (Smart UI repo): react/source/toast/basic/App.jsx

1 Create a Vite + React + TypeScript app

  1. npm create vite@latest my-smart-app -- --template react-ts
  2. cd my-smart-app
    then
    npm install

2 Install Smart UI for React

npm install smart-webcomponents-react

3 Import styles and render the component

Open src/App.tsx (or App.jsx if you chose JavaScript). The snippet below matches Smart UI React demos for this widget:

import 'smart-webcomponents-react/source/styles/smart.default.css';
import './App.css';
import React from "react";
import { Toast } from 'smart-webcomponents-react/toast';

const App = () => {
  return (
    <div>
      <Toast
        position="top-left"
        autoOpen
        showCloseButton
        type="mail"
        className="blink"
      >
        You have 2 new messages.
      </Toast>
    </div>
  );
};

export default App;

4 Run the dev server

npm run dev

Open the URL Vite prints (often http://localhost:5173/).

Alternative: Next.js

Create an app with npx create-next-app@latest (Pages Router or App Router). Install the same package (npm install smart-webcomponents-react), then reuse the imports and default export from step 3 in pages/_app.tsx, the App Router root app/layout.tsx, or your top-level layout component so styles and the widget tree load once.

Common Use Cases

  • Show notification

    Display a toast message

    toast.open();
  • Auto-close notification

    Set toast to dismiss automatically

    toast.autoClose = true;
    toast.autoCloseDelay = 3000;
    toast.open();

Troubleshooting

How do I show different toast types?
Set the type property to 'info', 'success', 'warning', or 'error' for different visual styles.
How do I position toasts?
Set the position property to 'top-left', 'top-right', 'bottom-left', or 'bottom-right'.

TypeScript Support

Types ship with smart-webcomponents-react. Import the component and prop types:

import type { Toast, ToastProps } from 'smart-webcomponents-react/toast';

The generated wrappers expose on* callbacks (for example onChange) whose arguments are standard DOM Event values unless the widget typings narrow them further.

Accessibility

The Toast component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.

Angular Toast - Setup

Smart UI for Angular supports both standalone components (bootstrapApplication) and NgModule-based apps (bootstrapModule(AppModule)). Steps 1-5 show the standalone path; the section below shows the NgModule path with the same package and styles.

Demo source (Smart UI repo): angular/src/toast/basic

1 NPM Install

Install the smart-webcomponents-angular package:

npm install smart-webcomponents-angular

2 Register styles

Add the default Smart UI stylesheet to angular.json -> projects -> <your-project> -> architect -> build -> options -> styles (merge with existing entries):

"styles": [
		"node_modules/smart-webcomponents-angular/source/styles/smart.default.css"
	]

Add optional theme CSS from the same package after smart.default.css if you use Bootstrap, Fluent, or other bundled themes.

3 Import the Angular module

Import ToastModule from smart-webcomponents-angular/toast: use @Component.imports for standalone, or add it to your AppModule (or feature module) imports array for NgModule apps.

import { ToastModule } from 'smart-webcomponents-angular/toast';

4 Root component (standalone)

Add ToastModule to your root standalone component (src/app/app.ts). Snippet from Smart UI demos (paths normalized to app.html / App where applicable):

 import { Component, ViewChild, OnInit, AfterViewInit } from '@angular/core';
import { ToastComponent } from 'smart-webcomponents-angular/toast';

import { ToastModule } from 'smart-webcomponents-angular/toast';

@Component({
  selector: 'app-root',
  standalone: true,
  imports: [ ToastModule ],
  templateUrl: './app.html',
  styleUrl: './app.css'
})

export class App implements AfterViewInit, OnInit {	
	@ViewChild('toast', { read: ToastComponent, static: false }) toast!: ToastComponent;
	
 
	ngOnInit(): void {
		// onInit code.
	}

	ngAfterViewInit(): void {
		// afterViewInit code.
		this.init();
    }
		
	init(): void {
		// init code.
	    

	}	
}

Boot the app with bootstrapApplication from src/main.ts and an ApplicationConfig in src/app/app.config.ts as generated by the CLI.

5 Template (standalone)

Use your markup in src/app/app.html (or inline template). Bind properties and events on smart-toast as needed:

 <smart-toast #toast [position]="'top-left'" [autoOpen]="true" [showCloseButton]="true" [type]="'mail'" class="blink">You
    have 2 new messages.</smart-toast>

6 NgModule bootstrap (also supported)

Same npm package and angular.json styles as steps 1-2. Put ToastModule on your NgModule.imports instead of @Component.imports, and bootstrap with bootstrapModule(AppModule).

The demo sources bundled for this widget use standalone only (there is no app.module.ts in that folder). NgModule is fully supported: put ToastModule from smart-webcomponents-angular/toast on NgModule.imports, make your root component non-standalone (remove standalone: true and move widget modules from @Component.imports to the module), and bootstrap with platformBrowserDynamic().bootstrapModule(AppModule).

Minimal main.ts + app.module.ts pairing (adjust paths to match your CLI layout):

src/main.ts

import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { AppModule } from './app/app.module';

platformBrowserDynamic().bootstrapModule(AppModule).catch((err) => console.error(err));

src/app/app.module.ts

import { NgModule } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import { ToastModule } from 'smart-webcomponents-angular/toast';

@NgModule({
	declarations: [ AppComponent ],
	imports: [ BrowserModule, ToastModule ],
	bootstrap: [ AppComponent ]
})
export class AppModule { }

Reuse the template and class logic from steps 4-5 in AppComponent, configured for declarations + NgModule.imports instead of a standalone @Component.

Run

ng serve or npm start - then open http://localhost:4200/.

Smart UI for Angular - full documentation

Common Use Cases

  • Show notification

    Display a toast message

    toast.open();
  • Auto-close notification

    Set toast to dismiss automatically

    toast.autoClose = true;
    toast.autoCloseDelay = 3000;
    toast.open();

Troubleshooting

How do I show different toast types?
Set the type property to 'info', 'success', 'warning', or 'error' for different visual styles.
How do I position toasts?
Set the position property to 'top-left', 'top-right', 'bottom-left', or 'bottom-right'.

Accessibility

The Toast component follows WAI-ARIA best practices:

  • Keyboard navigation - Tab, Arrow keys, Enter, and Escape are supported
  • ARIA roles - Appropriate roles and labels are applied automatically
  • Focus management - Visible focus indicators for keyboard users
  • Screen readers - State changes are announced to assistive technology
  • High contrast - Supports Windows High Contrast Mode and forced colors

For custom labeling, set aria-label or aria-labelledby attributes on the component.

Live demos

Supported stacks: Smart UI targets Angular 17+, React 18+, Vue 3+, Node 18 LTS, and evergreen browsers; pin exact package versions to your org policy.